<script setup lang="ts">
import { onMounted, ref } from 'vue'
import TableLayout from '@/layouts/TableLayout.vue'
import { useCustomerStore } from '../stores/customer'
import SearchTableField from '@/components/SearchTableField.vue'
import CustomerDialog from '../components/customerDialog.vue'
const customerStore = useCustomerStore()

const searchText = ref()

onMounted(async () => {
  await customerStore.getAll()
})

function handleSearchText(value: string) {
  searchText.value = value
}
</script>

<template>
  <CustomerDialog></CustomerDialog>
  <TableLayout
    title="Customer Management"
    has-action
    :items="customerStore.items"
    :headers="customerStore.headers"
    :search="searchText"
    customColumnName="image"
  >
    <template #image="{ item }">
      <v-img
        :src="'http://localhost:3000/images/customers/' + item.image"
        width="100"
        height="100"
      ></v-img>
    </template>
    <template #topCardText>
      <v-row>
        <v-col cols="6">
          <SearchTableField @get-search-text="handleSearchText" />
        </v-col>
        <v-col cols="3">
          <v-btn
            prepend-icon="mdi-plus"
            color="#FFD180"
            rounded="xl"
            class="w-100"
            @click="customerStore.openDialog()"
            >New</v-btn
          >
        </v-col>
      </v-row>
    </template>
    <template #actions="{ item }">
      <v-icon size="small" class="me-2" @click="customerStore.editItem(item)"> mdi-pencil </v-icon>
      <v-icon size="small" @click="customerStore.deleteItem(item)"> mdi-delete </v-icon>
    </template>
  </TableLayout>
</template>

<style scoped></style>

<!-- <script setup lang="ts">
import { useCustomerStore } from '../stores/customer'
import customerDialog from '../components/customerDialog.vue'
import { onMounted } from 'vue'
const customerStore = useCustomerStore()

onMounted(async () => {
  await customerStore.getAll()
})
</script>

<template>
  <customerDialog />
  <v-data-table
    class="h-100"
    fixed-header
    :headers="customerStore.headers"
    :items="customerStore.items"
  >
    <template #top>
      <v-card class="pa-5" color="#77625d">
        <v-row>
          <v-col>
            <h2>Customer Management</h2>
          </v-col>
          <v-col cols="1">
            <v-btn @click="customerStore.openDialog()" color="#FFD180"> NEW </v-btn>
          </v-col>
        </v-row>
      </v-card>
    </template>

    <template #item="{ item }">
      <tr>
        <td>{{ item.id }}</td>
        <td>{{ item.name }}</td>
        <td>{{ item.tel }}</td>
        <td>{{ item.registerDate?.toString() }}</td>
        <td>{{ item.birthDay.toString() }}</td>
        <td>{{ item.point }}</td>
        <td>{{ item.status }}</td>
        <td>
          <v-icon size="small" class="me-2" @click="customerStore.editItem(item)">
            mdi-pencil
          </v-icon>
          <v-icon size="small" @click="customerStore.deleteItem(item)"> mdi-delete </v-icon>
        </td>
      </tr>
    </template>
  </v-data-table>
</template>

<style scoped></style> -->
